Crypto++ 8.2 Free C++ class library of cryptographic schemes

Public Member Functions | List of all members
ElGamalBase Class Referenceabstract

ElGamal key agreement and encryption schemes base class. More...

Inheritance diagram for ElGamalBase:

## Public Member Functions
void | Derive (const DL_GroupParameters< Integer > &groupParams, byte *derivedKey, size_t derivedLength, const Integer &agreedElement, const Integer &ephemeralPublicKey, const NameValuePairs &derivationParams) const
size_t | GetSymmetricKeyLength (size_t plainTextLength) const
size_t | GetSymmetricCiphertextLength (size_t plainTextLength) const
size_t | GetMaxSymmetricPlaintextLength (size_t cipherTextLength) const
void | SymmetricEncrypt (RandomNumberGenerator &rng, const byte *key, const byte *plainText, size_t plainTextLength, byte *cipherText, const NameValuePairs &parameters) const
DecodingResult | SymmetricDecrypt (const byte *key, const byte *cipherText, size_t cipherTextLength, byte *plainText, const NameValuePairs &parameters) const
virtual const DL_GroupParameters_GFP & | GetGroupParameters () const =0
Public Member Functions inherited from DL_KeyAgreementAlgorithm_DH< Integer, NoCofactorMultiplication >
Element | AgreeWithEphemeralPrivateKey (const DL_GroupParameters< Element > &params, const DL_FixedBasePrecomputation< Element > &publicPrecomputation, const Integer &privateExponent) const
Element | AgreeWithStaticPrivateKey (const DL_GroupParameters< Element > &params, const Element &publicElement, bool validateOtherPublicKey, const Integer &privateExponent) const
Public Member Functions inherited from DL_KeyDerivationAlgorithm< Integer >
virtual bool | ParameterSupported (const char *name) const
Public Member Functions inherited from DL_SymmetricEncryptionAlgorithm
virtual bool | ParameterSupported (const char *name) const

## Additional Inherited Members
Public Types inherited from DL_KeyAgreementAlgorithm_DH< Integer, NoCofactorMultiplication >
typedef Integer | Element
Public Types inherited from DL_KeyAgreementAlgorithm< Integer >
typedef Integer | Element
Static Public Member Functions inherited from DL_KeyAgreementAlgorithm_DH< Integer, NoCofactorMultiplication >
static const char *CRYPTOPP_API | StaticAlgorithmName ()

## Detailed Description

ElGamal key agreement and encryption schemes base class.

Since
  Crypto++ 1.0

Definition at line 23 of file elgamal.h.

The documentation for this class was generated from the following file:

- elgamal.h